--- old/usr/src/uts/common/fs/smbsrv/smb2_dispatch.c	2020-04-15 01:43:37.180497394 +0000
+++ new/usr/src/uts/common/fs/smbsrv/smb2_dispatch.c	2020-04-15 01:43:37.185676756 +0000
@@ -11,7 +11,7 @@
 
 /*
  * Copyright 2019 Nexenta Systems, Inc.  All rights reserved.
- * Copyright 2019 RackTop Systems.
+ * Copyright 2020 RackTop Systems, Inc.
  */
 
 
@@ -973,6 +973,16 @@
 	 */
 	(void) smb2_encode_header(sr, B_TRUE);
 
+	/*
+	 * Cannot move this into smb2_session_setup() - encoded header required.
+	 */
+	if (session->dialect >= SMB_VERS_3_11 &&
+	    sr->smb2_cmd_code == SMB2_SESSION_SETUP &&
+	    sr->smb2_status == NT_STATUS_MORE_PROCESSING_REQUIRED) {
+		(void) smb31_preauth_sha512_calc(sr, &sr->reply,
+		    session->smb31_preauth_hashval);
+	}
+
 	/* Don't sign if we're going to encrypt */
 	if (sr->tform_ssn == NULL &&
 	    (sr->smb2_hdr_flags & SMB2_FLAGS_SIGNED) != 0)
@@ -1109,8 +1119,8 @@
 		disconnect = B_TRUE;
 		goto cleanup;
 	}
-	sr->smb2_hdr_flags |=  (SMB2_FLAGS_SERVER_TO_REDIR |
-				SMB2_FLAGS_ASYNC_COMMAND);
+	sr->smb2_hdr_flags |= (SMB2_FLAGS_SERVER_TO_REDIR |
+	    SMB2_FLAGS_ASYNC_COMMAND);
 	sr->smb2_async_id = SMB2_ASYNCID(sr);
 
 	/*
